$dirsep = "\\" #Windows
class Qhull
	def Qhull::mesh
		qfile=File.dirname(__FILE__)+$dirsep+"qhull"+$dirsep+"qhull.exe"
		qfile=qfile.gsub('/',$dirsep)
		qcom=qfile + " TI qhull"+$dirsep+"points.txt"
		qmethod=" Qj"
		qparams=" o"
		qexport=" TO qhull"+$dirsep+"qhull.txt"

		#output to file
		system(qcom + qmethod + qparams + qexport)
		
		points_file_path=File.dirname(__FILE__)+$dirsep+"qhull"+$dirsep+"qhull.txt"
		points=File.new(points_file_path.to_s,"r") #opens the input file
	  table_lines = IO.readlines(points_file_path.to_s)
		dimensions = table_lines[0].to_i
		numbers = table_lines[1].split
		number_of_vertices = numbers[0].to_i
		number_of_faces = numbers[1].to_i

		#(table_lines.length-1)/2-1
	  #UI.messagebox(number_of_vertices.to_s + " points to import, faces:" + number_of_faces.to_s )

		Sketchup.active_model.start_operation "Build faces"
			if (dimensions == 3) then
				facelayer=Sketchup.active_model.layers.add("3D Hull")
				facelayer.visible=true
			else
				edgelayer=Sketchup.active_model.layers.add("2D Hull")
				edgelayer.visible=true
			end
			
			startline = 2+number_of_vertices
			#UI.messagebox table_lines[startline]
			#return nil
			0.upto(number_of_faces-1) do |i|
				facepoints = table_lines[i+startline].split
				ptf = []
				current_point = []
				removepoint = 0
				normalpos = 0
				facepoints.delete_at(0) #removes the first item specifying the number of face verticies
				#UI.messagebox facepoints.to_s
				0.upto(facepoints.length-1) do |j|
					if facepoints[j].to_i >= 0 and facepoints[j].to_i <= number_of_vertices then
						current_point = table_lines[facepoints[j].to_i+2].split
						x = (current_point[0].to_f.to_l)
						y = (current_point[1].to_f.to_l)
						if(dimensions == 3) then
							z = (current_point[2].to_f.to_l)
						else
							z = 0.to_f
						end
						ptf[j-removepoint] = Geom::Point3d.new(x,y,z)
					else 
						removepoint = removepoint + 1
					end
				end
				stepbystep = 0
				#stepbystep = UI.messagebox "Do you want to construct Face: " + (i+1).to_s + ", press No to skip.", MB_YESNOCANCEL, "Proceed"	#use to validate each face before its drawn
				if stepbystep == 2
					return nil
				end
				if(stepbystep == 6 or stepbystep == 0) then #when the answer is yes
					#UI.messagebox "create plane"
					#UI.messagebox i.to_s + ": " + ptf.length.to_s + "   >" + ptf.to_s
					if(dimensions == 3) then
							drawfaces = Sketchup.active_model.active_entities.add_face(ptf)
							drawfaces.layer = facelayer
					else
						drawedges = Sketchup.active_model.active_entities.add_edges(ptf)
						if drawedges
							drawedges.each{|e| e.layer=edgelayer}
						end
					end
				end # if stepbystep
			end #loop
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $tooling_sub_menu )
	$tooling_sub_menu = UI.menu("Plugins").add_submenu("Qhull")
end
if( not $qhull_menu_loaded )
	$tooling_sub_menu.add_item("Convex Hull") { Qhull.mesh }
	$qhull_menu_loaded = true
end
